{{ $appSection := "performance-tests" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
{{- if index . "Values" $appSection "enabled" -}}
apiVersion: batch/v1
kind: Job
metadata:
  name: {{ $appName }}-job
  labels:
    app.kubernetes.io/name: {{ $appName }}
    {{- include "performance-tests.labels" . | nindent 4 }}
  annotations:
    "helm.sh/hook": post-install,post-upgrade
    "helm.sh/hook-delete-policy": before-hook-creation
    rollme: {{ randAlphaNum 7 | quote }}
    {{- include "performance-tests.annotations" . | nindent 4 }}
spec:
  backoffLimit: 0
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ $appName }}
        {{- include "performance-tests.labels" . | nindent 8 }}
      annotations:
        {{- include "performance-tests.annotations" . | nindent 8 }}
    spec:
      serviceAccountName: {{ include "performance-tests.serviceAccountName" . }}
      restartPolicy: Never
      terminationGracePeriodSeconds: {{ .Values.global.terminationGracePeriodSeconds }}
      containers:
        - name: {{ $appName }}
          image: {{ include "performance-tests.imageName" (list . $appSection) | quote }}
          command: [ /bin/sh, -c ]
          args: ["npm run start;echo '<resultk6>';cat .k6-output.json ; echo '</resultk6>';"]
          imagePullPolicy: Always
          env:
            - name: NODE_ENV
              value: "development"
            - name: LOG_LEVEL
              value: {{ index .Values $appSection "logLevel" | quote }}
            - name: POSTGRES_DUPLICATION_ENABLED
              value: "false"
            - name: POSTGRES_DUPLICATION_METHOD
              value: "fdw"
            - name: POSTGRES_DUPLICATION_TARGET_CONNECTION
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: duplicationTargetConnection
            - name: POSTGRES_DUPLICATION_SCHEMA
              value: "pid"
            - name: POSTGRES_DUPLICATION_TABLE_REGEXPS
              value: {{ index .Values $appSection "postgresDuplicationRegexp" | quote }}
            - name: POSTGRES_DUPLICATION_FDW_SERVER
              value: "vehicle_positions_rabin"
            - name: POSTGRES_DUPLICATION_FDW_SCHEMA
              value: "pid_fdw"
            - name: PERF_SCRIPT
              value: "vehicle-positions.js"
            - name: INPUT_BATCH_IMPORT_ENABLED
              value: "false"
            - name: INPUT_BATCH_IMPORT_PARALLEL_RUN
              value: "false"
            - name: INPUT_BATCH_IMPORT_PARALLEL_RUN_WAIT_TIME
              value: "30" # in seconds
            - name: INPUT_BATCH_IMPORT_TIME_RANGE
              value: "0-0" # Set 0-0 to import all data from zip archives
            - name: INPUT_BATCH_IMPORT_TCP_TRAM_TARGET
              value: "tcp-input-gateway-pt:3000"
            - name: INPUT_BATCH_IMPORT_TCP_BUS_TARGET
              value: "tcp-input-gateway-pt:3002"
            - name: INPUT_BATCH_IMPORT_HTTP_TARGET
              value: "http://input-gateway-v1-pt:3000/vehiclepositions"
            - name: INPUT_BATCH_IMPORT_TCP_TRAM_CONCURRENCY
              value: "1" # Set number of messages per TCP connection
            - name: INPUT_BATCH_IMPORT_TCP_BUS_CONCURRENCY
              value: "1" # Set number of messages per TCP connection
            - name: INPUT_BATCH_IMPORT_TCP_TRAM_SLEEP_TIME
              value: "700" # Sleep time between connections/requests, in milliseconds
            - name: INPUT_BATCH_IMPORT_TCP_BUS_SLEEP_TIME
              value: "700" # Sleep time between connections/requests, in milliseconds
            - name: INPUT_BATCH_IMPORT_HTTP_SLEEP_TIME
              value: "15000" # Sleep time between connections/requests, in milliseconds
          resources:
            {{- index . "Values" $appSection "resources" | toYaml | nindent 12 }}
          volumeMounts:
            - name: {{ $appName }}-config
              mountPath: /app/config/k6.json
              subPath: configK6.js
              readOnly: true
            - name: batch-import
              mountPath: /app/batch-import
      volumes:
        - name: {{ $appName }}-config
          configMap:
            name: {{ $appName }}-config
            items:
              - key: configK6.js
                path: configK6.js
        - name: batch-import
          persistentVolumeClaim:
            claimName: {{ $appName }}-pvc
      tolerations:
        {{ index . "Values" $appSection "tolerations" | toYaml | nindent 8 }}
      nodeSelector:
        {{ index . "Values" $appSection "nodeSelector" | toYaml | nindent 8 }}
{{ end }}
